﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.Threading.Tasks;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            int workerT, portT;
            int minRequire = 25;

            ThreadPool.GetMinThreads(out workerT, out portT);
            Trace.WriteLine(string.Format("Min: worker - {0}, port - {1}", workerT, portT));

            if (workerT < minRequire)
            {
                int inc = minRequire - workerT;
                workerT += inc;
            }
            ThreadPool.SetMinThreads(workerT, portT);

            for (int i = 0; i < 20; i++)
            {
                DateTime started = DateTime.Now;

                //ThreadPool.QueueUserWorkItem(
                //    (obj) =>
                //    {
                //        TimeSpan elapsed = DateTime.Now - (DateTime)obj;
                //        Trace.WriteLine(Thread.CurrentThread.ManagedThreadId + ": Work started after " + elapsed);

                //        Thread.Sleep(1000 * 60);
                //    }, started);

                //Task.Factory.StartNew((obj) =>
                //{
                //    TimeSpan elapsed = DateTime.Now - (DateTime)obj;
                //    Trace.WriteLine(Thread.CurrentThread.ManagedThreadId + ": Work started after " + elapsed);

                //    Thread.Sleep(1000 * 60);
                //}, started);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 20; i++)
            {
                BackgroundWorker bgw = new BackgroundWorker();
                bgw.DoWork += new DoWorkEventHandler(bgw_DoWork);
                bgw.WorkerSupportsCancellation = true;
                bgw.RunWorkerAsync(DateTime.Now);
            }
        }

        void bgw_DoWork(object sender, DoWorkEventArgs e)
        {
            DateTime started = (DateTime)e.Argument;

            TimeSpan elapsed = DateTime.Now - started;

            Trace.WriteLine(Thread.CurrentThread.ManagedThreadId + ": Work started after " + elapsed);
            Thread.Sleep(1000 * 60);
        }
    }
}
